"""
This module was written in 2017 during my S8 project.

It contains functions draw_pi_qew_tree and generer_pi_qew_tree to generate document .tex with latex code to
generate pi_qew_tree which you input(you can try it with the 4 pi_qew_trees I have put here: l1, l2, l3, l4)

This is pi_qew_tree_version 1: all the nodes are generated naturally to different directions.
"""

__author__ = 'LI Guodong'

FILE_NAME = "pi_qew_tree_version1"

new_list1 = []
new_list2 = []


def gutemberg(x):
    print(x)
    if THE_FILE is not None:
        THE_FILE.write(x + "\n")


def traversal(pi_qew_tree):
    for i in pi_qew_tree:
        if type(i) is not list:
            new_list1.append(i)
        if type(i) is list:
            traversal(i)


def traversal_by_list(pi_qew_tree):
    for i in pi_qew_tree:
        if type(i) is list:
            new_list2.append(i)
            traversal_by_list(i)


def add_blank_lines(nb_lines):
    for i in range(nb_lines):
        gutemberg("%")


def draw_pi_qew_tree(pi_qew_tree):
    for i in pi_qew_tree:
        if type(i) is int:
            gutemberg("[" + str(i) + "]")
        if type(i) is list:
            if i[0] == 'P_node':
                gutemberg("[, circle,draw,")
            if i[0] == 'Q_node':
                gutemberg("[, round corner,draw,")
            for j in i:
                if type(j) is int:
                    gutemberg("[" + str(j) + "]")
                if type(j) is list:
                    if j[0] == 'P_node':
                        gutemberg("[, circle,draw,")
                    if j[0] == 'Q_node':
                        gutemberg("[, round corner,draw,")
                    draw_pi_qew_tree(j)
                    gutemberg("]")
            gutemberg("]")
            add_blank_lines(1)


def generer_pi_qew_tree(pi_qew_tree):
    add_blank_lines(1)
    traversal(pi_qew_tree)
    traversal_by_list(pi_qew_tree)
    if pi_qew_tree[0] == 'P_node':
        gutemberg("[, circle,draw,")
        add_blank_lines(1)
        draw_pi_qew_tree(pi_qew_tree)
        gutemberg("]")
    if pi_qew_tree[0] == 'Q_node':
        gutemberg("[, round corner,draw,")
        add_blank_lines(1)
        draw_pi_qew_tree(pi_qew_tree)
        gutemberg("]")


"""program
"""
print("\n\n")


if FILE_NAME is not None and len(FILE_NAME) > 0:
    THE_FILE = open(FILE_NAME + ".tex", "w")
else:
    THE_FILE = None


l1 = ['Q_node', 8, 5, 4, 7, 1, ['P_node', 0, ['Q_node', 1, 3], 9, 2, 6], 1, 2]
l2 = ['P_node', 6, ['Q_node', 9, 5, 8, 3, 0, ['P_node', 2, 1], ['P_node', 7, 4]]]
l3 = ['P_node', 1, ['Q_node', ['P_node', 16, 14, 2, 11], ['P_node', 0, 10], 12, 13, 15, ['P_node', 4, 19, 6], 17, ['P_node', 18, 7, 3, 5, 8, 9]]]
l4 = ['Q_node', 16, 18, 3, 17, ['Q_node', 6, ['P_node', 7, 8, 11, 4, ['P_node', 14, 0]], ['P_node', 2, 5, 1], ], ['P_node', 5, 3, 13, 12, 12, 12], ['P_node', 5, 3, ['P_node', 4, 2, 18, 16], 13], ['P_node', 5, 3]]

gutemberg("\\documentclass[tikz,border=5pt]{standalone}")
gutemberg("\\usepackage{forest}")
gutemberg("\\usetikzlibrary{arrows.meta, angles}")
gutemberg("\\begin{document}")
gutemberg("\\begin{forest}")
generer_pi_qew_tree(l4)
gutemberg("\\end{forest}")
gutemberg("\\end{document}")
print(new_list1)
