"""
This module was written in 2017 during my S8 project.

It contains functions draw_pi_qew_tree and generer_pi_qew_tree to generate document .tex with latex code to
generate pi_qew_tree which you input(line195, you can try it with the 4 pi_qew_trees I have put here: l1, l2, l3, l4)

The value "shadow" can be changed with the P_node or Q_node that you want to add shadow effect（line 23）.
If "shadow" is P_node, a P-Node is represented by an ellipse with shadow;
If "shadow" is Q_node, a Q-Node is represented by a rectangle with shadow;

This is pi_qew_tree_version 3: all the nodes are generated to the vertical directions and all the numbers will
be written at the bottom level of the pi_qew_tree graph.
"""


__author__ = 'LI Guodong'

FILE_NAME = "pi_qew_tree_version3"

new_list1 = []
new_list2 = []
new_list3 = []
# shadow = 'P_node'
# shadow = 'Q_node'
shadow = 'no shadow'


def gutemberg(x):
    print(x)
    if THE_FILE is not None:
        THE_FILE.write(x + "\n")


def traversal(pi_qew_tree):
    for i in pi_qew_tree:
        if type(i) is not list:
            new_list1.append(i)
        if type(i) is list:
            traversal(i)


def traversal_by_list(pi_qew_tree):
    for i in pi_qew_tree:
        if type(i) is list:
            new_list2.append(i)
            traversal_by_list(i)


def add_blank_lines(nb_lines):
    for i in range(nb_lines):
        gutemberg("%")


def traversal_by_int(pi_qew_tree):
    for i in pi_qew_tree:
        if type(i) is not list and type(i) is int:
            new_list3.append(i)
        if type(i) is list:
            traversal_by_int(i)
    length = int(len(new_list3)*1.05)
    return length


def draw_pi_qew_tree(pi_qew_tree):
    global a
    for i in pi_qew_tree:
        # print(str(type(i)))
        if type(i) is str:
            if shadow == 'P_node':
                if i == 'P_node':
                    gutemberg("[,ellipse=" + str(traversal_by_int(new_list2[a])) + ",patt,*|")
                    print(new_list3)
                    while len(new_list3) > 0:
                        new_list3.pop()
                if i == 'Q_node':
                    gutemberg("[,rect=" + str(traversal_by_int(new_list2[a])) + ",*|")
                    print(new_list3)
                    while len(new_list3) > 0:
                        new_list3.pop()
            if shadow == 'Q_node':
                if i == 'P_node':
                    gutemberg("[,ellipse=" + str(traversal_by_int(new_list2[a])) + ",*|")
                    print(new_list3)
                    while len(new_list3) > 0:
                        new_list3.pop()
                if i == 'Q_node':
                    gutemberg("[,rect=" + str(traversal_by_int(new_list2[a])) + ",patt,*|")
                    print(new_list3)
                    while len(new_list3) > 0:
                        new_list3.pop()
            if shadow == 'no shadow':
                if i == 'P_node':
                    gutemberg("[,ellipse=" + str(traversal_by_int(new_list2[a])) + ",*|")
                    print(new_list3)
                    while len(new_list3) > 0:
                        new_list3.pop()
                if i == 'Q_node':
                    gutemberg("[,rect=" + str(traversal_by_int(new_list2[a])) + ",*|")
                    print(new_list3)
                    while len(new_list3) > 0:
                        new_list3.pop()
        elif type(i) is int:
            gutemberg("[" + str(i) + "]")
        elif type(i) is list:
            a += 1  # What I want is not the depth, so 'a' has to be a global variable
            # print("ok", a)
            draw_pi_qew_tree(i)
            gutemberg("]")
            add_blank_lines(1)


def generer_pi_qew_tree(pi_qew_tree):
    global a
    add_blank_lines(1)
    new_list2.append(pi_qew_tree)
    traversal(pi_qew_tree)
    traversal_by_list(pi_qew_tree)
    a = 0
    draw_pi_qew_tree(pi_qew_tree)
    gutemberg("]")


"""program
"""
print("\n\n")


if FILE_NAME is not None and len(FILE_NAME) > 0:
    THE_FILE = open(FILE_NAME + ".tex", "w")
else:
    THE_FILE = None


l1 = ['Q_node', 8, 5, 4, 7, 1, ['P_node', 0, ['Q_node', 1, 3], 9, 2, 6], 1, 2]
l2 = ['P_node', 6, ['Q_node', 9, 5, 8, 3, 0, ['P_node', 2, 1], ['P_node', 7, 4]]]
l3 = ['P_node', 1, ['Q_node', ['P_node', 16, 14, 2, 11], ['P_node', 0, 10], 12, 13, 15, ['P_node', 4, 19, 6], 17, ['P_node', 18, 7, 3, 5, 8, 9]]]
l4 = ['P_node', 16, 18, 3, 17, ['Q_node', 6, ['P_node', 7, 8, 11, 4, ['P_node', 14, 0]], ['P_node', 2, 5, 1], ], ['P_node', 5, 3, 13, 12, 12, 12], ['P_node', 5, 3, ['P_node', 4, 2, 18, 16], 13], ['P_node', 5, 3]]

gutemberg("\\documentclass[border=10pt]{standalone}")
gutemberg("\\usepackage{forest}")
gutemberg("\\usetikzlibrary{shapes.geometric,patterns}")
gutemberg("\\usetikzlibrary{arrows.meta, angles}")
gutemberg("\\forestset{")
gutemberg("*|/.style={")
gutemberg("parent anchor=south,")
gutemberg("for descendants={")
gutemberg(" edge path={")
gutemberg("\\noexpand\\path[\\forestoption{edge}]")
gutemberg("(!u.parent anchor-|.child anchor) -- (.child anchor)\\forestoption{edge label};")
gutemberg("}")
gutemberg("}")
gutemberg("},")
gutemberg("normal width/.initial=.45cm,")
gutemberg("normal height/.initial=.3cm,")
gutemberg("every forest node/.style={")
gutemberg("draw,")
gutemberg("minimum width=\\pgfkeysvalueof{/forest/normal width},")
gutemberg("minimum height=\\pgfkeysvalueof{/forest/normal height},")
gutemberg("inner sep=+0pt,")
gutemberg("anchor=south,")
gutemberg("},")
gutemberg("rect/.style={")
gutemberg("every forest node,")
gutemberg("shape=rectangle,")
gutemberg("minimum width=(#1)*(\\pgfkeysvalueof{/forest/normal width})+(#1+1)*""(\\forestove{s sep})-(#1)*(\\pgfkeysvalueof{/pgf/outer xsep}),")
gutemberg(" },")
gutemberg("rect/.default=3,")
gutemberg("ellipse/.style={")
gutemberg("	every forest node,")
gutemberg("	shape=ellipse,")
gutemberg("minimum width=(#1)*(\\pgfkeysvalueof{/forest/normal width})+(#1+1)*(\\forestove{s sep})-(#1)*(\\pgfkeysvalueof{/pgf/outer xsep}),")
gutemberg("},")
gutemberg("ellipse/.default=3,")
gutemberg("patt/.style args={#1:#2}{")
gutemberg("node options={")
gutemberg("/tikz/path picture={")
gutemberg("\\pgfsetfillpattern{north east lines}{black}")
gutemberg("\\pgfpathrectanglecorners")
gutemberg("{\\pgfpointlineattime{#1}")
gutemberg("{\\pgfpointanchor{path picture bounding box}{north west}}")
gutemberg("{\\pgfpointanchor{path picture bounding box}{north east}}}")
gutemberg("{\\pgfpointlineattime{#2}")
gutemberg("{\\pgfpointanchor{path picture bounding box}{south west}}")
gutemberg("{\\pgfpointanchor{path picture bounding box}{south east}}}")
gutemberg("\\pgfusepath{fill}")
gutemberg("}")
gutemberg("    }")
gutemberg("  },")
gutemberg("  patt/.default=0:1")
gutemberg("}")
gutemberg("\\begin{document}")
gutemberg("\\begin{forest} %for tree={child anchor=north}")
gutemberg("	 for tree={child anchor=parent},")
gutemberg("where n children=0{tier=terminus}{},")
generer_pi_qew_tree(l4)
gutemberg("\\end{forest}")
gutemberg("\\end{document}")
# print(new_list2)
